#!/usr/bin/env groovy

library identifier: 'jenkins-shared-library@main', retriever: modernSCM(
    [$class: 'GitSCMSource',
    remote: 'https://gitlab.com/mailo.shawn/jenkins-shared-library.git',
    credentialsID: 'gitlab-credentials'
    ]
)

pipeline {
    agent any
    tools {
        maven 'maven-3.9'
    }
    environment {
        IMAGE_NAME = 'chonzao/java-maven-app:1.1.8-11'
        AWS_ACCESS_KEY_ID = credentials('jenkins_aws_access_key_id')
        AWS_SECRET_ACCESS_KEY = credentials('jenkins_aws_secret_access_key')
    }

    stages {
        stage('build app') {
            steps {
               script {
                   echo "building the application..."
                   buildJar()
               }
            }
        }
        stage('build image') {
            steps {
                script {
                    echo "building the docker image..."
                    buildImage(env.IMAGE_NAME)
                    dockerLogin()
                    dockerPush(env.IMAGE_NAME)
                }
            }
        }
        stage('deploy') {
            // environment {
            //     AWS_ACCESS_KEY_ID = credentials('jenkins_aws_access_key_id')
            //     AWS_SECRET_ACCESS_KEY = credentials('jenkins_aws_secret_access_key')
            // }
            steps {
                script {
                    def dockerCmd = "docker run -p 8080:8080 -d ${IMAGE_NAME}"
                    echo 'deploying docker image...'
                    sshagent(['ec2-server-key']) {
                        sh "ssh -o StrictHostKeyChecking=no ec2-user@18.132.38.72 ${dockerCmd}"
                   }
                //    sh 'kubectl create deployment nginx-deployment --image=nginx'
                }
            }
        }
    }
}